import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Plane here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Plane extends Actor
{
    private GreenfootImage R1 = new GreenfootImage("Plane1.png");
    private GreenfootImage R2 = new GreenfootImage("Plane2.png");
    private GreenfootImage R3 = new GreenfootImage("Plane3.png");
    private GreenfootImage R4 = new GreenfootImage("Plane4.png");
    private GreenfootImage R5 = new GreenfootImage("Plane5.png");
    private GreenfootImage R6 = new GreenfootImage("Plane6.png");
    private int count;
    private int imageNumber;
    private int life = 6;
    private static final int gunReloadTime = 25;
    private int reloadDelayCount = 15;
    // UserInfo score = UserInfo.getMyInfo();
    public Plane()
    {
        // Greenfoot.ask("What is Your Name");
    }

    /**
     * Act - do whatever the Plane wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        keyMove();

        reloadDelayCount++;
        showLife();
        dead();
    }   

    public void keyMove()
    {

        if(Greenfoot.isKeyDown("up"))
        {

            moveUp();
            if (getY() < 25)
            {
                setLocation(getX(), getY()+8);
            }

            setLocation(getX(), getY()-8);

        }
        if(Greenfoot.isKeyDown("down"))
        {

            moveDown();
            if (getY() > 270)
            {
                setLocation(getX(), getY()-8);
            }
            setLocation(getX(), getY()+8);

        } if(Greenfoot.isKeyDown("left"))
        {
            setLocation(getX()-8, getY());
            moveLeft();

        } if(Greenfoot.isKeyDown("right"))
        {
            setLocation(getX()+8, getY());
            moveRight();

        }
        if(Greenfoot.isKeyDown("z"))
        {
            Shoot();
            addChute(getX()+12, getY()+10);
        }
        if (Greenfoot.isKeyDown("space"))
        {
            Shoot2();
            addFlash(getX()+25, getY());
        }
    }

    public void Shoot()
    {
        if(reloadDelayCount >= gunReloadTime)
        {
            getWorld().addObject(new Bomb(), getX(), getY());
            Greenfoot.playSound("9_mm_gunshot-mike-koenig-123.mp3");
            reloadDelayCount = 1;

        }
    }

    public void addFlash(int x, int y)
    {
        Flash flash = new Flash();
        getWorld().addObject(flash, x, y);

    }

    public void addChute(int x, int y)
    {
        Chute chute = new Chute();
        getWorld().addObject(chute, x, y);

    }

    public void Shoot2()
    {
        if(reloadDelayCount >= gunReloadTime)
        {
            getWorld().addObject(new Missile(), getX(), getY());
            Greenfoot.playSound("9_mm_gunshot-mike-koenig-123.mp3");
            reloadDelayCount = 1;
        }
    }

    public void showLife()
    {
        getWorld().showText("HP: " + life, 925, 25);

    }

    public void moveUp()
    {
        if (count % 10 == 0)
        {

            imageNumber++;
            if (imageNumber == 7) imageNumber = 1;
            setImage("Plane" + imageNumber + ".png");
        }
        count++;

    }

    public void moveDown()
    {
        if (count % 10 == 0)
        {

            imageNumber++;
            if (imageNumber == 7) imageNumber = 1;
            setImage("Plane" + imageNumber + ".png");
        }
        count++;

    }

    public void moveLeft()
    {
        if (count % 10 == 0)
        {

            imageNumber++;
            if (imageNumber == 7) imageNumber = 1;
            setImage("Plane" + imageNumber + ".png");
        }
        count++;
    }

    public void moveRight()
    {
        if (count % 10 == 0)
        {

            imageNumber++;
            if (imageNumber == 7) imageNumber = 1;
            setImage("Plane" + imageNumber + ".png");
        }
        count++;
    }

    public void dead()
    {
        if (isTouching(BadPlane.class))
        {
            removeTouching(BadPlane.class);
            life--;

        }
        else
        if (isTouching(CannonBall.class))
        {
            removeTouching(CannonBall.class);
            life--;

        }
        else
        if (isTouching(Bullet.class))
        {
            removeTouching(Bullet.class);
            life--;

        }
        else
        if (isTouching(Asteroid.class))
        {
            removeTouching(Asteroid.class);
            life--;

        }
        else
        if (isTouching(Helicopter.class))
        {
            removeTouching(Helicopter.class);
            life--;

        }
        if(life == 0)
        {

            
            MyWorld world = (MyWorld)getWorld();
               
            
            Greenfoot.setWorld(new GameOver(world.score));

        }
    }
}
